package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.RmEnterprisePerformanceStandard;
import com.zksy.system.basicData.service.RmEnterprisePerformanceStandardService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 企业绩效评价标准Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/rmEnterprisePerformanceStandard")
@Api(tags = "企业绩效评价标准", description = "企业绩效评价标准desc")
public class RmEnterprisePerformanceStandardController extends BaseController{

    @Autowired
    private RmEnterprisePerformanceStandardService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "企业绩效评价标准搜索getById")
    public RmEnterprisePerformanceStandard getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "企业绩效评价标准分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "企业绩效评价标准查询所有")
    public List<RmEnterprisePerformanceStandard> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增企业绩效评价标准
     */
    @PostMapping("/save")
    @ApiOperation(value = "企业绩效评价标准新增")
    @Log(title = "新增企业绩效评价标准", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody RmEnterprisePerformanceStandard rmEnterprisePerformanceStandard) {
        return service.save(rmEnterprisePerformanceStandard);
    }

    /**
     * 修改企业绩效评价标准
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "企业绩效评价标准修改")
    @Log(title = "修改企业绩效评价标准", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody RmEnterprisePerformanceStandard rmEnterprisePerformanceStandard) {
        return service.updateById(rmEnterprisePerformanceStandard);
    }

    /**
     * 导入企业绩效评价标准
     */
    @ApiOperation("企业绩效评价标准导入")
    @Log(title = "企业绩效评价标准", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<RmEnterprisePerformanceStandard> rmEnterprisePerformanceStandardAll = service.list();
            List<RmEnterprisePerformanceStandard> list = ExcelUtils.readMultipartFile(file, RmEnterprisePerformanceStandard.class,RmEnterprisePerformanceStandard.class.getDeclaredFields().length - 2);
            if(rmEnterprisePerformanceStandardAll != null && rmEnterprisePerformanceStandardAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("企业绩效评价标准导出")
    @Log(title = "企业绩效评价标准", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<RmEnterprisePerformanceStandard> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"企业绩效评价标准",wrapperList,RmEnterprisePerformanceStandard.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "企业绩效评价标准", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除企业绩效评价标准", notes = "删除企业绩效评价标准")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"企业绩效评价标准模板");
    }
}

